﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Win32;
using System.IO;

namespace _2012_06_05_12_xx_Praktikum_Loesung
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        OpenFileDialog ofd = new OpenFileDialog(); // Nicht immer wieder neu konstruieren, damit der Dialog das Verzeichnis behält.
        string filename;

        private void buttonChooseTextFile_Click(object sender, RoutedEventArgs e)
        {
            ofd.Filter = "Textdateien|*.txt";
            if (ofd.ShowDialog() == true) // "== true" ist erforderlich, weil ShowDialog einen "bool?" liefert
            {
                filename = ofd.FileName;
            }
        }

        private void buttonFind_Click(object sender, RoutedEventArgs e)
        {
            listBoxResults.Items.Clear();
            canvasResult.Children.Clear();
            string searchTerm = textBoxSearchTerm.Text;
            if (searchTerm == "")
            {
                return;
            }
            
            StreamReader sr = null;
            try
            {
                sr = new StreamReader(filename);
                const int baseLength = 100;
                const int contextLength = 20;
                char[] buffer = new char[baseLength + searchTerm.Length + contextLength];
                string textFrame = "";
                string textBefore = "";
                List<int> positions = new List<int>();
                int positionOfTextFrame = 0;
                while (!sr.EndOfStream)
                {
                    int numCharsRead = sr.ReadBlock(buffer, 0, buffer.Length);
                    textFrame += new string(buffer, 0, numCharsRead);
                    while (true)
                    {
                        int ind = textFrame.IndexOf(searchTerm);
                        if(ind >= 0 && (ind < textFrame.Length - searchTerm.Length - contextLength || sr.EndOfStream))
                        {
                            textBefore += textFrame.Substring(0, ind);
                            int m = Math.Min(contextLength, textBefore.Length);
                            textBefore = textBefore.Substring(textBefore.Length - m, m);

                            string snippet = textBefore + textFrame.Substring(ind, Math.Min(searchTerm.Length + contextLength, textFrame.Length - ind));
                            snippet = snippet.Replace("\r\n", " ");
                            snippet = snippet.Replace("\n", " ");
                            snippet = snippet.Replace("\r", " ");
                            listBoxResults.Items.Add("..." + snippet + "...\n");

                            int cutBy = ind + searchTerm.Length;
                            textFrame = textFrame.Substring(cutBy);
                            positionOfTextFrame += cutBy;
                            positions.Add(positionOfTextFrame - searchTerm.Length);
                        }
                        else
                        {
                            int cutBy = textFrame.Length - searchTerm.Length - contextLength;
                            if (cutBy > 0)
                            {
                                textBefore += textFrame.Substring(0, cutBy);
                                int m = Math.Min(contextLength, textBefore.Length);
                                textBefore = textBefore.Substring(textBefore.Length - m, m);

                                textFrame = textFrame.Substring(cutBy);
                                positionOfTextFrame += cutBy;
                            }
                            
                            break;
                        }
                    }
                }

                int totalLength = positionOfTextFrame + textFrame.Length;
                foreach (int p in positions)
                {
                    Line line = new Line();
                    line.X1 = canvasResult.Width*p/(double)totalLength;
                    line.X2 = line.X1;
                    line.Y1 = 0;
                    line.Y2 = canvasResult.Height;
                    line.Stroke = Brushes.Red;
                    line.StrokeThickness = 2.0;
                    line.Opacity = 0.3;
                    canvasResult.Children.Add(line);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ein Fehler ist aufgetreten:\n" + ex.Message);
            }
            finally // Dies würde mit "using(StreamReader sr = new ..." überflüssig.
            {
                if (sr != null)
                {
                    sr.Close();
                }
            }
        }
    }
}
